<template>
  <div class="tree-table-container">
    <!-- <div class="drag-box" ref="drag-box">
      <div class="drag-left">
        <div class="common-tree-container">
          <div class="common-tree-title">
            <i class="el-icon-menu"></i> 备件库管理目录
          </div>
          <div class="common-tree-content">
            <el-tree highlight-current v-if="treeData.length" :data="treeData" :props="defaultProps"
              :render-content="renderContent" @node-click="handleNodeClick" default-expand-all>
            </el-tree>
          </div>
        </div>
      </div>
      <div class="drag-resize" title="收缩侧边栏">
        ⋮
      </div>
      <div class="drag-mid"> -->
    <div class="common-table-container">
      <div class="bbsl-common-page">
        <div class="bbsl-table-search">
          <el-form label-width="auto">
            <el-row :gutter="10">
              <el-col :span="5">
                <el-form-item label="备件名称">
                  <el-input maxlength="128" clearable v-model="querys[0].value" placeholder="请输入备件名称">
                  </el-input>
                </el-form-item>
              </el-col>
              <el-col :span="5">
                <el-form-item label="备件规格">
                  <el-input maxlength="128" clearable v-model="querys[1].value" placeholder="请输入备件规格">
                  </el-input>
                </el-form-item>
              </el-col>
              <el-col :span="5">
                <el-form-item label="备件类型">
                  <el-select clearable style="width: 100%" v-model="querys[2].value" placeholder="请选择备件类型">
                    <el-option v-for="item in SpareTypes" :key="item.value" :label="item.name"
                      :value="item.value"></el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="4">
                <el-button type="primary" icon="el-icon-search" autofocus @click="handleSearch">搜索
                </el-button>
                <el-button icon="el-icon-refresh" @click="handleReset">重置</el-button>
              </el-col>
            </el-row>
          </el-form>
        </div>
        <div class="bbsl-table-content" ref="contentPanel">
          <div class="bbsl-btn-content" ref="btnPanel">
            <el-button icon="el-icon-plus" type="primary" @click="openFormDiao">新增</el-button>
            <el-popconfirm title="确定删除选中数据吗？" @confirm="handleDelete">
              <el-button slot="reference" :disabled="!multipleSelection.length" icon="el-icon-delete"
                style="margin-left: 10px" type="danger">删除
              </el-button>
            </el-popconfirm>
          </div>
          <el-table border size="mini" v-loading="loading" ref="multipleSelection" :data="tableData"
            :style="{ width: '100%' }" :max-height="tableMaxHeight" :cell-style="{ 'text-align': 'center' }"
            :header-cell-style="{ 'text-align': 'center' }" @row-dblclick="handleDbClick"
            @selection-change="handleSelectionChange">
            <el-table-column type="selection" width="55"></el-table-column>
            <el-table-column fixed type="index" width="60" label="序号"></el-table-column>
            <el-table-column min-width="130" fixed prop="spareCode" label="备件代码" show-overflow-tooltip>
            </el-table-column>
            <el-table-column fixed min-width="150" prop="spareName" label="备件名称" show-overflow-tooltip>
            </el-table-column>
            <el-table-column min-width="150" prop="spareSpecs" label="备件规格" show-overflow-tooltip>
            </el-table-column>
            <el-table-column width="80" prop="spareType" label="备件类型" show-overflow-tooltip>
              <template #default="scope">
                <div>
                  {{
                    scope.row.spareType == 1
                      ? '电子'
                      : scope.row.spareType == 2
                        ? '机械'
                        : ''
                  }}
                </div>
              </template>
            </el-table-column>
            <el-table-column width="80" prop="spareNum" label="备件数量" show-overflow-tooltip>
            </el-table-column>
            <el-table-column min-width="120" prop="companyName" label="备件供应商" show-overflow-tooltip>
            </el-table-column>
            <el-table-column min-width="140" prop="memo" label="备注" show-overflow-tooltip>
            </el-table-column>
          </el-table>
          <el-pagination ref="paginationPanel" align="right" class="bbsl-pagination" background
            :current-page="queryParam.pageBean.page" :page-sizes="[20, 30, 40, 50]"
            :page-size="queryParam.pageBean.pageSize" layout="total, sizes, prev, pager, next, jumper"
            :total="total"></el-pagination>
        </div>
      </div>
    </div>
    <!-- </div> -->
    <!-- </div> -->
    <!-- 新增修改备件弹窗 -->
    <spareManageModal @closeFormDiao="closeFormDiao" @loadData="loadData" :pId="pId" ref="formModal">
    </spareManageModal>
    <!-- 备件库弹窗 -->
    <!-- 备品库弹窗 -->
    <!-- <spareWarehouseDialog @loadData="loadData" ref="WarehouseDia" @getTreen="getTreen"></spareWarehouseDialog> -->
  </div>
</template>

<script>
import {
  TableMixin
} from '@/mixins/tableMixin'
import {
  dragControllerDiv
} from '@/mixins/dragControllerDiv'
import SpareManageModal from '@/views/Device/resourceManage/components/spareManageDialog'
import spareWarehouseDialog from '@/views/Device/resourceManage/components/spareWarehouseDialog'
import Spares from '@/api/device/SpareManage.js'
import SpareWarehouse from '@/api/device/SpareWarehouse.js'
import dictSpare from '@/components/dict/DictSelectUtils.js'

export default {
  name: 'SpareManage',
  mixins: [TableMixin],
  components: {
    SpareManageModal,
    spareWarehouseDialog
  },
  data() {
    return {
      url: {
        delete: '/device/base/spare/'
      }, // 备件删除信息
      loading: false, // 页面加载
      showFormDia: false, //备件弹窗显示
      showMore: false,
      pId: '', //修改时传的id值
      multipleSelection: [], // 复选框
      SpareTypes: [], //备件类型
      // 备件库树
      treeData: [],
      treeNode: {
        code: '',
        id: 0,
        name: '备件库管理',
        type: 0,
        children: []
      },
      defaultProps: {
        children: 'children',
        label: 'warehouseName'
      },
      // 查询条件传参
      querys: [{
        group: 'main',
        operation: 'LIKE',
        parentGroup: '',
        property: 'spareName',
        relation: 'AND',
        value: ''
      },
      {
        group: 'main',
        operation: 'EQUAL',
        parentGroup: '',
        property: 'spareSpecs',
        relation: 'AND',
        value: ''
      },
      {
        group: 'main',
        operation: 'EQUAL',
        parentGroup: '',
        property: 'spareType',
        relation: 'AND',
        value: ''
      },
      {
        group: 'main',
        operation: 'EQUAL',
        parentGroup: '',
        property: 'warehouseId',
        relation: 'AND',
        value: ''
      }
      ],
      total: 0, // 总条目数
      tableData: [] // 备件列表数据
    }
  },
  computed: {},
  created() {
    this.SpareTypes = dictSpare.getDictItemsFromCache('bjlx')
    // this.getTreen()
  },
  mounted() {
    dragControllerDiv()
  },
  methods: {
    // 打开搜索更多
    openMore() {
      this.showMore = !this.showMore
    },
    // 删除单个备件库信息
    SpareWarehouseDelete(item) {
      this.$confirm('确定删除选中数据？', '提示', {
        distinguishCancelAndClose: true,
        confirmButtonText: '确 定',
        cancelButtonText: '取 消'
      })
        .then(() => {
          SpareWarehouse.removeSpareWarehouse(item.id).then(res => {
            if (res.data.state) {
              this.$notify({
                type: 'success',
                message: '删除成功',
                duration: 2000
              })
              // this.getTreen()
            }
          })
        })
        .catch(action => {
          this.$notify({
            type: 'info',
            message: action === 'cancel' ? '已取消删除' : '停留在当前页面'
          })
        })
    },
    // 备品库新增
    append() {
      this.$refs.WarehouseDia.add()
    },
    // 备品库修改
    upDateinfo(data, type) {
      console.log(data)
      this.$refs.WarehouseDia.edit(data)
    },
    // 备件库组织树查询
    getTreen() {
      SpareWarehouse.findSWList({}, res => {
        this.treeData = res.rows
        this.$set(this.treeData)
      })
    },
    // renderContent(h, {node, data, store}) {
    //   return (
    //     <span
    //       class="custom-tree-node"
    //       on-mouseover={() => {
    //         this.show = true
    //       }}
    //       on-mouseout={() => {
    //         this.show = false
    //       }}
    //     >
    //       <span>{data.warehouseName}</span>
    //       <span>
    //         <el-popover placement="bottom" width="55" trigger="hover">
    //           <el-button
    //             v-show={data.id == 0}
    //             style="width:100%;border:0;margin:0;color:#606266;"
    //             size="mini"
    //             type="text"
    //             icon="el-icon-plus"
    //             on-click={() => this.append()}
    //           >
    //             新增
    //           </el-button>
    //           <el-button
    //             v-show={data.id}
    //             style="width:100%;border:0;margin:0;color:#606266;"
    //             size="mini"
    //             type="text"
    //             icon="el-icon-edit"
    //             on-click={() => this.upDateinfo(data, '')}
    //           >
    //             修改
    //           </el-button>
    //           <el-button
    //             v-show={data.id}
    //             style="width:100%;border:0;margin:0;color:#606266;"
    //             size="mini"
    //             icon="el-icon-delete"
    //             type="text"
    //             on-click={() => this.SpareWarehouseDelete(data)}
    //           >
    //             删除
    //           </el-button>
    //           <i
    //             slot="reference"
    //             class="el-icon-more-outline"
    //             style="font-size: 15px;"
    //           ></i>
    //         </el-popover>
    //       </span>
    //     </span>
    //   )
    // },
    // 重置
    clearQuerys() {
      this.querys[0].value = ''
      this.querys[1].value = ''
      this.querys[2].value = ''
    },
    // 新增备件
    openFormDiao() {
      this.$refs.formModal.add()
    },
    // 关闭备件增改弹窗
    closeFormDiao() {
      this.$refs.formModal.closeFormDiao()
    },
    // 备件修改
    handleUpdate(row) {
      // console.log(row)
      this.pId = row.id
      this.$refs.formModal.Update(row)
    },
    // 获取备件信息
    loadData(page) {
      if (page) {
        this.queryParam.pageBean.page = page
      }
      this.loading = true
      this.tableData = []
      this.queryParam.querys = []
      if (this.querys[0].value) {
        this.queryParam.querys.push(this.querys[0])
      }
      if (this.querys[1].value) {
        this.queryParam.querys.push(this.querys[1])
      }
      if (this.querys[2].value) {
        this.queryParam.querys.push(this.querys[2])
      }
      if (this.querys[3].value) {
        this.queryParam.querys.push(this.querys[3])
      }
      Spares.findSMList(this.queryParam, res => {
        this.total = res.total
        this.tableData = res.rows
        this.$set(this.tableData)
        this.loading = false
      })
    },
    // 点击备件库查看备件信息
    handleNodeClick(data) {
      this.treeNode = data
      console.log(this.treeNode, 'ssssss')
      if (data.id == '0') {
        this.querys[3].value = this.treeNode.id
        this.loadData(1)
      } else {
        this.querys[3].value = this.treeNode.id
        this.loadData(1)
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.common-tree-container {
  width: 100% !important;
}

.common-tree-container ::v-deep .el-tree {
  border: none;
}

::v-deep .custom-tree-node {
  span {
    font-size: 14PX !important;
  }
}

::v-deep .el-tree-node>.el-tree-node__children {
  overflow: visible;
}
</style>
